﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using GrapeCity.Windows.SpreadSheet.Data;

namespace ConditionalFormatting_CS
{
    public partial class MainPage : UserControl
    {
        int r = 3;
        int c = 1;
        int w = 10;
        int h = 8;
        public MainPage()
        {
            InitializeComponent();
            textBlock1.TextWrapping = TextWrapping.Wrap;
            textBlock1.Text ="Select any conditional format rule from drop down.";
            string[] cbstr;
            cbstr = new String[] { "No Conditional Formatting Rule","Iconset Rule", "DataBar Rule", "CellValue Rule", "Average Rule", "Duplicate Rule" };
            comboBox1.SelectedItem="No Conditional Formatting Rule";
            comboBox1.ItemsSource = cbstr;
            comboBox1.SelectionChanged += new SelectionChangedEventHandler(comboBox1_SelectionChanged);

            Worksheet sheet = gcSpreadSheet1.ActiveSheet;
            var increase = 0;
            for (int row = 0; row < h - 1; row++)
            {
                for (int col = 0; col < w; col++)
                {
                    sheet.SetValue(row + r + 1, col + c, increase);
                    increase += 10;
                }
            }
            sheet.SetBorder(new CellRange(r, c, h, w), new BorderLine(Colors.Black, BorderLineStyle.Dashed), SetBorderOptions.All);
        }

        void comboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //throw new NotImplementedException();
            Worksheet sheet = gcSpreadSheet1.ActiveSheet;
            var combo = sender as ComboBox;
            string val =(String) combo.SelectedItem;
          
            if (val == "Iconset Rule")
            {
               textBlock1.Text = "Five arrows are shown in cell to format the value with different color."; 
               sheet.ConditionalFormats.ClearRule();              
               sheet.ConditionalFormats.AddIconSetRule(IconSetType.FiveArrowsColored, new CellRange(r + 1, c, h - 1, w));
            }
            if (val == "DataBar Rule")
            {
                textBlock1.Text = "Data bars are shown in each cell with maximum data limit set to 700."; 
                sheet.ConditionalFormats.ClearRule();              
                sheet.ConditionalFormats.AddDataBarRule(ScaleValueType.Number, 0, ScaleValueType.Number, 700, Colors.Brown, new CellRange(r, c, h, w));                
            }
            if (val == "CellValue Rule")
            {
                textBlock1.Text = "All cells with value more than 300 and less than 500 are formatted with lightGray back color and Red fore color."; 
                sheet.ConditionalFormats.ClearRule();              
                GrapeCity.Windows.SpreadSheet.Data.StyleInfo myValueStyle = new StyleInfo();
                myValueStyle.Background = new SolidColorBrush(Colors.LightGray);
                myValueStyle.Foreground = new SolidColorBrush(Colors.Red);
                sheet.ConditionalFormats.AddCellValueRule(ComparisonOperator.Between, 300, 500, myValueStyle, new CellRange(r, c, h, w));
            }
            if (val == "Average Rule")
            {
                textBlock1.Text = "All cells with value less than the average of this group of cells are formatted with Green back color and yellow as forecolor.";
                sheet.ConditionalFormats.ClearRule();              
                GrapeCity.Windows.SpreadSheet.Data.StyleInfo myAverageStyle = new StyleInfo();
                myAverageStyle.Background = new SolidColorBrush(Colors.Green);
                myAverageStyle.Foreground = new SolidColorBrush(Colors.Yellow);               
                sheet.ConditionalFormats.AddAverageRule(AverageConditionType.Below, myAverageStyle, new CellRange(r, c, h, w));
            }
            if (val == "Duplicate Rule")
            {
                textBlock1.Text = "It finds duplicate values with in a given range of cells and apply style with making the font bold and highlighting with White forecolor.";
                sheet.ConditionalFormats.ClearRule();              
                GrapeCity.Windows.SpreadSheet.Data.StyleInfo myDuplicateStyle = new StyleInfo();
                myDuplicateStyle.Background = new SolidColorBrush(Colors.Red);
                myDuplicateStyle.Foreground = new SolidColorBrush(Colors.White);
                myDuplicateStyle.FontWeight = FontWeights.Bold;
                
                sheet.ConditionalFormats.AddDuplicateRule(myDuplicateStyle, new CellRange(r, c, h, w));
            }
            if (val == "No Conditional Formatting Rule")
            {
                textBlock1.Text = "No conditional formatting rule is applied to cells";
                sheet.ConditionalFormats.ClearRule();            
            }
        }
    }
}
